/*
 * Proyecto MiCasa, version 1.
 * Copyright (C) 2002 Grzegorz Adam Hankiewicz <gradha@terra.es> y
 * Jon Lpez de Dicastillo <darwater@hotmail.com>.
 * Curso 2001-2002
 * Facultad de Ingeniera
 * Universidad de Deusto
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package MiCasa;

import java.net.ServerSocket;
import java.io.IOException;

/**
 * La clase DemonioCasa se encarga de escuchar solicitudes de conexin
 * por el puerto 'puertoPasivoDemonio', aceptarlas y asignarles
 * servidores.
 */
public class DemonioCasa extends Thread
{
   /** Puerto al que hacer la conexin con el servidor. */
   private final static int puertoPasivoDemonio = 6969;
   
   /** Socket de tipo servidor para escuchar solicitudes de conexin. */
   ServerSocket ss;

   /**
    * Constructor del DemonioSat, que escuchar constantemente el puerto.
    */
   public DemonioCasa() {
      try {
         ss = new ServerSocket(puertoPasivoDemonio);
         System.out.println("Servidor escuchando en el puerto " +
            puertoPasivoDemonio);
      }
      catch(IOException ioe) {
         System.err.println("DemonioCasa.constructor: " + ioe);
      }
   }

   /**
    * Lleva a cabo un proceso infinito de espera de una solicitud de
    * conexin, creando un ServidorCasa y ponindolo en funcionamiento
    * por cada peticin recibida por el socket.
    */
   public void run() {
      while(true) {
         try {
            ServidorCasa sCasa = new ServidorCasa(ss.accept());
            sCasa.start();
         }
         catch(IOException ioe) {
            System.err.println("DemonioCasa.run: " + ioe);
         }
      }
   }
}
