/*
 * Proyecto MiCasa, version 1.
 * Copyright (C) 2002 Grzegorz Adam Hankiewicz <gradha@terra.es> y
 * Jon Lpez de Dicastillo <darwater@hotmail.com>.
 * Curso 2001-2002
 * Facultad de Ingeniera
 * Universidad de Deusto
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package MiCasa;

import java.awt.Dialog;
import java.awt.Panel;
import java.awt.TextField;
import java.awt.Label;
import java.awt.GridLayout;
import java.awt.FlowLayout;
import java.awt.Button;
import java.awt.Frame;
import java.awt.event.WindowEvent;
import java.awt.event.ActionEvent;
import java.awt.AWTEvent;

/**
 * Muestra un dialogo con dos campos para que el usuario introduzca
 * los parmetros de la conexin.
 */
public class DialogoIniciarConexion extends Dialog {
   boolean aceptar = false;
   /** Nombre de la mquina a la que se quiere conectar */
   TextField textoHost = new TextField("localhost", 20);
   /** Puerto al que se quiere conectar */
   TextField textoPuerto = new TextField("6969", 6);
   
   /**
    * Ajusta/crea todos los elementos grficos.
    * @return Devuelve el panel principal.
    */
   private Panel IniciarDialogo() throws Exception {
      Panel panel = new Panel(new GridLayout(2, 1));
      
      Panel panelTitle = new Panel();
      panel.add(panelTitle);
      panelTitle.add(new Label("Datos conexin servidor MiCasa:"));

      Panel panelOptions = new Panel(new GridLayout(3, 2));
      panel.add(panelOptions);
      panelOptions.add(new Label("Dirreccin IP:"));
      panelOptions.add(textoHost);
      panelOptions.add(new Label("Puerto:"));
      panelOptions.add(textoPuerto);

      Button boton;
      boton = new Button("Conectar a servidor");
      boton.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(ActionEvent e) { BotonConectar(e); }});
      panelOptions.add(boton);

      boton = new Button("Cancelar conexin");
      boton.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(ActionEvent e) { BotonCancelar(e); }});
      panelOptions.add(boton);
      return panel;
   }

   /**
    * Constructor del dilogo.
    */
   public DialogoIniciarConexion(Frame frame) {
      super(frame, "Datos conexin", true);
      enableEvents(AWTEvent.WINDOW_EVENT_MASK);
      try {
         add(IniciarDialogo());
         pack();
      }
      catch(Exception ex) {
         ex.printStackTrace();
      }
   }

   /**
    * Gestiona los mensajes de la ventana. Simplemente recoge el de
    * cierre de ventana para cancelar la operacin.
    */
   protected void processWindowEvent(WindowEvent e) {
      if (e.getID() == WindowEvent.WINDOW_CLOSING) {
         dispose();
      }
      super.processWindowEvent(e);
   }

   /**
    * Devuelve la direccin IP del servidor introducido.
    */
   public String Host() { return textoHost.getText(); }

   /**
    * Devuelve el puerto de conexin introducido.
    */
   public String Puerto() { return textoPuerto.getText(); }

   /**
    * Indica si se cerr el dilogo aceptando.
    */
   public boolean Aceptar() { return aceptar; }

   /**
    * Llamado cuando el usuario pincha en el botn de cancelar.
    */
   private void BotonCancelar(ActionEvent e) { dispose(); }
   
   /**
    * Llamado cuando el usuario pincha en el botn de conectar.
    */
   private void BotonConectar(ActionEvent e) { aceptar = true; dispose(); }
}

