/*
 * Proyecto MiCasa, version 1.
 * Copyright (C) 2002 Grzegorz Adam Hankiewicz <gradha@terra.es> y
 * Jon Lpez de Dicastillo <darwater@hotmail.com>.
 * Curso 2001-2002
 * Facultad de Ingeniera
 * Universidad de Deusto
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package MiCasa;

import java.awt.Dialog;
import java.awt.Panel;
import java.awt.TextField;
import java.awt.Label;
import java.awt.GridLayout;
import java.awt.Button;
import java.awt.Frame;
import java.awt.event.WindowEvent;
import java.awt.event.ActionEvent;
import java.awt.AWTEvent;

/**
 * Muestra un dialogo con dos campos para que el usuario introduzca
 * su nombre de usuario y clave.
 */
public class DialogoUsuarioClave extends Dialog {
   boolean continuar = false;
   Label mensaje = new Label();
   /** Guarda el nombre del usuario */
   TextField textoUsuario = new TextField("root", 20);
   /** La clave del usuario */
   TextField textoClave = new TextField("supermacho", 20);
   
   /**
    * Ajusta/crea todos los elementos grficos.
    * @return El panel principal.
    */
   private Panel IniciarDialogo(String m) throws Exception {
      Panel panel = new Panel(new GridLayout(2, 1));
      Panel panelTitle = new Panel();
      panel.add(panelTitle);
      mensaje.setText(m);
      panelTitle.add(mensaje);

      Panel panelOptions = new Panel(new GridLayout(3, 2));
      panel.add(panelOptions);
      panelOptions.add(new Label("Usuario:"));
      panelOptions.add(textoUsuario);
      panelOptions.add(new Label("Clave:"));
      panelOptions.add(textoClave);

      Button boton;
      boton = new Button("Aceptar");
      boton.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(ActionEvent e) { BotonAceptar(e); }});
      panelOptions.add(boton);

      boton = new Button("Cancelar");
      boton.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(ActionEvent e) { BotonCancelar(e); }});
      panelOptions.add(boton);
      return panel;
   }

   /**
    * Constructor del dilogo. Se le pasa el mensaje que hay que visualizar
    * por encima de los cuadros donde el usuario introduce su clave. Esto
    * permite modificar el mensaje si se abre el mismo dilogo varias
    * veces seguidas.
    */
   public DialogoUsuarioClave(Frame frame, String mensaje) {
      super(frame, "Autentificacin", true);
      enableEvents(AWTEvent.WINDOW_EVENT_MASK);
      try {
         add(IniciarDialogo(mensaje));
         pack();
      }
      catch(Exception ex) {
         ex.printStackTrace();
      }
   }

   /**
    * Gestiona los mensajes de la ventana. Simplemente recoge el de
    * cierre de ventana para cancelar la operacin.
    */
   protected void processWindowEvent(WindowEvent e) {
      if (e.getID() == WindowEvent.WINDOW_CLOSING) {
         cancel();
      }
      super.processWindowEvent(e);
   }

   /**
    * Cierra el dilogo por cancelacin.
    */
   private void cancel() { continuar = false; dispose(); }

   /**
    * Devuelve la direccin IP del servidor introducido.
    */
   public String Usuario() { return textoUsuario.getText(); }

   /**
    * Devuelve el puerto de conexin introducido.
    */
   public String Clave() { return textoClave.getText(); }

   /**
    * Indica si se cerr el dilogo aceptando.
    */
   public boolean Continuar() { return continuar; }

   /**
    * Llamado cuando el usuario pincha en el botn de cancelar.
    */
   private void BotonCancelar(ActionEvent e) { cancel(); }
   
   /**
    * Llamado cuando el usuario pincha en el botn de conectar.
    */
   private void BotonAceptar(ActionEvent e) { continuar = true; dispose(); }
}

