/*
 * Proyecto MiCasa, version 1.
 * Copyright (C) 2002 Grzegorz Adam Hankiewicz <gradha@terra.es> y
 * Jon Lpez de Dicastillo <darwater@hotmail.com>.
 * Curso 2001-2002
 * Facultad de Ingeniera
 * Universidad de Deusto
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package MiCasa;

/**
 * La clase ProgramaServidor es el programa principal del servidor.
 * Aparte de crear el demonio, antes verifica que se puede acceder
 * a la base de datos. Si no se puede, antes de fallar intenta
 * regenerar las bases de datos necesarias con datos bsicos.
 */
public class ProgramaServidor
{
   /** Punto de entrada del servidor.
    */
   public static void main(String[] args) {
      // Registramos el driver Mckoi JDBC
      try {
         Class.forName("com.mckoi.JDBCDriver").newInstance();
         System.out.println("Driver Mckoi registrado");
      }
      catch(Exception e) {
         System.out.println(
            "\nNo se pudo registrar el Driver JDBC Mckoi.\n" +
            "Asegrese que la ruta classpath es correcta. Teclee:\n\n" +
            " java -cp MckoiSQLDatabase/mckoidb.jar:. MiCasa/ProgramaServidor\n");
         return;
      }

      // Preintento de lectura/generacin
      if(!BaseDatos.LecturaPrevia()) {
         BaseDatos.GenerarVacia();
         if(!BaseDatos.LecturaPrevia()) {
            System.out.println("Segundo intento de conexin fallido. Abortando.");
            return;
         }
      }

      // Ahora realizamos la conexin permanente "de verdad"
      if(!BaseDatos.AbrirConexion())
         return;

      // Finalmente podemos crear el demonio
      DemonioCasa dc = new DemonioCasa();
      dc.start();
   }
}

